#=======================================================================
# Newtonlink   - transfer data between a Apple Newton Message Pad and
#                Unix applications
#
# Copyright (C) 1996-1998    The Newtonlink Developers
#                            (newtonlink@newton.bawue.de)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=======================================================================

#---------------------------------------------------------------------
# Get4Addressbook
#---------------------------------------------------------------------

# $Log: Get4Addressbook.pl,v $
# Revision 1.7  1998/03/07 12:37:33  kalli
# Umstellung auf neue ser. Treiber
#
# Revision 1.6  1997/12/06 17:17:17  kalli
# Umstellung auf Sloup
#
# Revision 1.5  1997/09/28 09:48:51  kalli
# Aenderungen von Andrew :
# select-Statement
#
# Revision 1.4  1997/03/27 19:33:28  kalli
# Andrew dazu
#
# Revision 1.3  1997/02/23 15:02:44  kalli
# Frank dazu
#
# Revision 1.2  1997/02/22 16:51:11  kalli
# GPL dazu
#
# Revision 1.1  1996/11/24 19:38:47  kalli
# Initial revision
#

sub Get4Addressbook {
    
    select((select(STDOUT), $|=1)[$[]);

    # start counter
    $PersonAddressesCounter = 0;
    $CompanyAddressesCounter = 0;
    $An = 0;

    # save old Addressbook file
    if (-e "$AddressbookFile") {
	rename ("$AddressbookFile", "$AddressbookFile.bak");
    }

    # Open file
    open (PFILE, ">> $AddressbookFile")  || die "Can't open File : $!\n";

    # send commands to Sloup
    &send_line (COMNEWTON, "Sloup");
    &send_line (COMNEWTON, "{}");
    &send_line (COMNEWTON, "Names");
    &send_line (COMNEWTON, '{class: "string", name: {last: "string", first: "string", honorific: "string"},' .
                           'address: "string", country: "string", postal_code: "string", city: "string", bday: "date",' .
                           'phones: ["homePhone", "workPhone", "faxPhone"],' .
                           'email: "string", company: "string"}');
    &send_line (COMNEWTON, "DUMP!");

    while (($_ = &receive_line (COMNEWTON)) ne "BYE!") {

	# replace german Umlaute
	s/\232//g; s/\212//g; s/\237//g; s/\247//g; s/\205//g; s/\200//g; s/\206//g;
	# split into
	($Aclass, $AlastName, $AfirstName, $Ahonorific, $Aaddress, $Acountry, $Apostal_code, $Acity,
	 $Abday, $AhomePhone, $AworkPhone, $AfaxPhone, $Aemail, $Acompany) = split(/\t/, $_, 20);

	if (defined ($Aclass) && (($Aclass eq "person") || ($Aclass eq "owner"))) {

	    # Print to STDOUT
	    print "#";
	    $PersonAddressCounter++;
	    # save to memory
	    $AdrArr[$An++] = "$AlastName;$AfirstName;$Ahonorific;$Aaddress;$Acountry;$Apostal_code;$Acity;$Abday;$AhomePhone;$AworkPhone;$AfaxPhone;$Aemail;$Acompany;";

	} elsif (defined ($Aclass) && ($Aclass eq "company")) {

	    # Print to STDOUT
	    print "#";
	    $CompanyAddressCounter++;
	    # save to memory
	    $AdrArr[$An++] = "$Acompany;;;$Aaddress;$Acountry;$Apostal_code;$Acity;;;$AhomePhone;$AfaxPhone;$Aemail;;";

	}
    }

    # print to stdout
    print ("\n$PersonAddressCounter person addresses transfered");
    print ("\n$CompanyAddressCounter company addresses transfered");

    # sort entrys
    @AdrArrSorted = sort @AdrArr;

    for ($Ai = 0; $Ai < $An; $Ai++) {
	printf PFILE "$AdrArrSorted[$Ai]\n";
    }

    # close file
    close (PFILE);
}

1;
