#=======================================================================
# Newtonlink   - transfer data between a Apple Newton Message Pad and
#                Unix applications
#
# Copyright (C) 1996-1998    The Newtonlink Developers
#                            (newtonlink@newton.bawue.de)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=======================================================================

#---------------------------------------------------------------------
# Get4Kjots
#---------------------------------------------------------------------

# $Log: Get4Kjots.pl,v $
# Revision 1.5  1998/03/16 14:57:33  kalli
# Umstellung auf ser. Treiber mit Timeout
#
# Revision 1.4  1998/03/07 17:29:44  kalli
# Umstellung auf neue ser. Treiber
#
# Revision 1.3  1998/02/07 19:54:48  kalli
# Aenderung von Torsten :
# Sortierund der Notes
#
# Revision 1.1  1998/02/01 18:07:51  kalli
# Initial revision
#

sub Get4Kjots {
    
    # start counter
    $KjNotesCounter = 0;

    $KjPaperCounter = 0;
    $KjListCounter  = 0;
    $KjCheckCounter = 0;

    $NewEntry       = 1;

    $Underline = "***********************************************************";

    # temporarily save Folder name
    $FolderName     = "";

    # save old Kjots file
    if (-e "$KjotsFile") {
	rename ("$KjotsFile", "$KjotsFile.bak");
    }
    # Open new Kjots file
    open (KJFILE, ">> $KjotsFile")  || die "Can't open File : $!\n";

    # submit Notes separated as paperroll, list, checkList
    # first line is Folder name,
    # second line is title of note

    print ("\nScanning for paperroll entries ...\n");

    # send commands to Sloup
    &send_line (COMNEWTON, "\nNotes");
    &send_line (COMNEWTON, '{class: \'paperroll,labels: \'_all,title: \'String}'); 
    &send_line (COMNEWTON, "DUMP!");

    while (($_ = &receive_line (COMNEWTON)) ne "BYE!") {

	if ($_ ne "") {

	    # replace german Umlaute
	    s/\232//g; s/\212//g;
	    s/\237//g;s/\247//g;s/\205//g;s/\200//g; s/\206//g;
	    s/\\u00F6\\u//g;

	    # Print sign to STDOUT
	    print "#";
	    $KjNotesCounter++;
            $KjPaperCounter++;

            if ($_ ne "-----") {

 	       # write to Kjots file
 	       if (($NewEntry == 1) || ($NewEntry == 2)) {
                 if ($NewEntry == 1) {

                   $FolderName = $_;
                   chomp $FolderName;
                   $NewEntry = 2;

                 } else {

                   if ($NewEntry == 2) {
   	             printf( KJFILE "\\NewEntry ");
                     printf( KJFILE $FolderName);
                     printf( KJFILE " / ");
	             print KJFILE "$_\n";

                     # Make a Header
	             print KJFILE "$_\n";
                     $LenOfTitle = length $_ ;
                     if ($LenOfTitle > 0) {
                       $LenOfTitle--;
                     }
                     $Underl = substr $Underline,0,$LenOfTitle;
                     printf (KJFILE $Underl);
                     printf (KJFILE "\n\n");
                     $NewEntry = 0;
                   }
 	         }
               } else {

	         print KJFILE "$_\n";
                 $NewEntry = 0;
               }

            } else {

               $NewEntry = 1;
               
            }
	}
    }

    # print to stdout
    print ("\n$KjPaperCounter lines of paperroll notes transfered");
    print ("\nNow scanning for list entries ...\n");

    # submit list entries

    # send commands to Sloup
    &send_line (COMNEWTON, "\nNotes");
    &send_line (COMNEWTON, '{class: \'list,labels: \'_all,title: \'String}'); 
    &send_line (COMNEWTON, "DUMP!");

    while (($_ = &receive_line (COMNEWTON)) ne "BYE!") {

	if ($_ ne "") {

	    # replace german Umlaute
	    s/\232//g; s/\212//g;
	    s/\237//g;s/\247//g;s/\205//g;s/\200//g; s/\206//g;
	    s/\\u00F6\\u//g; 

	    # Print sign to STDOUT
	    print "#";
	    $KjNotesCounter++;
            $KjListCounter++;

            if ($_ ne "-----") {

 	       # write to Kjots file
 	       if (($NewEntry == 1) || ($NewEntry == 2)) {
                 if ($NewEntry == 1) {

                   $FolderName = $_;
                   chomp $FolderName;
                   $NewEntry = 2;

                 } else {

                   if ($NewEntry == 2) {
   	             printf( KJFILE "\\NewEntry ");
                     printf( KJFILE $FolderName);
                     printf( KJFILE " / ");
	             print KJFILE "$_\n";

                     # Make a Header
	             print KJFILE "$_\n";
                     $LenOfTitle = length $_ ;
                     if ($LenOfTitle > 0) {
                       $LenOfTitle--;
                     }
                     $Underl = substr $Underline,0,$LenOfTitle;
                     printf (KJFILE $Underl);
                     printf (KJFILE "\n\n");
                     $NewEntry = 0;
                   }
 	         }
               } else {

	         print KJFILE "$_\n";
                 $NewEntry = 0;
               }

            } else {

               $NewEntry = 1;
               
            }

	}
    }

    # print to stdout
    print ("\n$KjListCounter lines of list notes transfered");
    print ("\nNow scanning for checklist entries ...\n");

    # submit checkList entries

    # send commands to Sloup
    &send_line (COMNEWTON, "\nNotes");
    &send_line (COMNEWTON, '{class: \'checkList,labels: \'_all,title: \'String}'); 
    &send_line (COMNEWTON, "DUMP!");

    while (($_ = &receive_line (COMNEWTON)) ne "BYE!") {

	if ($_ ne "") {

	    # replace german Umlaute
	    s/\232//g; s/\212//g;
	    s/\237//g;s/\247//g;s/\205//g;s/\200//g; s/\206//g;
	    s/\\u00F6\\u//g; 

	    # Print sign to STDOUT
	    print "#";
	    $KjNotesCounter++;
            $KjCheckCounter++;

            if ($_ ne "-----") {

 	       # write to Kjots file
 	       if (($NewEntry == 1) || ($NewEntry == 2)) {
                 if ($NewEntry == 1) {

                   $FolderName = $_;
                   chomp $FolderName;
                   $NewEntry = 2;

                 } else {

                   if ($NewEntry == 2) {
   	             printf( KJFILE "\\NewEntry ");
                     printf( KJFILE $FolderName);
                     printf( KJFILE " / ");
	             print KJFILE "$_\n";

                     # Make a Header
	             print KJFILE "$_\n";
                     $LenOfTitle = length $_ ;
                     if ($LenOfTitle > 0) {
                       $LenOfTitle--;
                     }
                     $Underl = substr $Underline,0,$LenOfTitle;
                     printf (KJFILE $Underl);
                     printf (KJFILE "\n\n");
                     $NewEntry = 0;
                   }
 	         }
               } else {

	         print KJFILE "$_\n";
                 $NewEntry = 0;
               }

            } else {

               $NewEntry = 1;
               
            }
	}
    }

    # print to stdout
    print ("\n$KjCheckCounter lines of checklist notes transfered");
    print ("\n$KjNotesCounter lines of notes totally transfered");

    # close file
    close (KJFILE);

    # now read KJFILE, sort and output
    print ("\nNotes file will now be sorted ...\n");
    # Open new Kjots file
    $KString = "";
    open (KJFILE, "$KjotsFile")  || die "Can't open File : $!\n";

    while ($i = <KJFILE>) {
      $KString = $KString.$i;
    }
    close (KJFILE);

    @KList = split ("\NewEntry", $KString);
    @KList = sort (@KList);
    $KString = join ("\NewEntry", @KList);
    open (KJFILE, "> $KjotsFile")  || die "Can't open File : $!\n";        
    
    printf (KJFILE "\\NewEntry");
    printf (KJFILE $KString);
    
    close (KJFILE);
    
}

1;



